#include "Mingyao.h"

int MingYao::CountAlleles(Mantra & m)
   {
   // return (pDA == 0.0) + (pDa == 0.0) + (pdA == 0.0) + (pda == 0.0);

   return 4;
   }


double MingYao::GetAlleleFrequency(int , int allele)
   {
   switch (allele)
      {
      case 0 : return pDA;
      case 1 : return pDa;
      case 2 : return pdA;
      case 3 : return pda;
      }
   }

double MingYao::JointProbability(Mantra & m)
   {
   // Retrieve allele frequency portion of likelihood for current state
   double lk = product.Peek();

   // Adjust likelihood according to the probability of observing each phenotype
   for (int i = 0; i < phenoList.Length(); i++)
      {
      int who = phenoList[i];

      int al1 = alleleState[m.state[who]];
      int al2 = alleleState[m.state[who + 1]];

      if (al1 < al2)
         lk *= penetrances[al2 * (al2 + 1) / 2 + al1][who / 2];
      else
         lk *= penetrances[al1 * (al1 + 1) / 2 + al2][who / 2];
      }

   return lk;
   }


