#ifndef __TREEINDEX_H__
#define __TREEINDEX_H__

#include "Tree.h"
#include "MathVector.h"

class IndexTree : public Tree
   {
   private:
      void UpdateFrequencies(const Tree & freqs, int n1, int n2, double w);
      void UpdateFrequencies(int node, double weigth);

      void EvenFrequencies(int node, double weigth);

   public:
      void MakeIndex(const Tree & source);
      void UpdateFrequencies(const Tree & freqs, double scale = 1.0);
      void EvenFrequencies();

      Vector uniqValues;
      Vector freqs;
   };

#endif
