#ifndef __AUTOFIT_H__
#define __AUTOFIT_H__

#include "MathNormal.h"
#include "Pedigree.h"

class NormalEquations;

class AutoFit
   {
   public:
      AutoFit();

      void FitPolygenicModels(Pedigree & ped, bool quiet = false);

      static bool   useCovariates;
      static bool   useProbands;

      Vector means, variances, heritabilities;
   };

#endif

 